/***********************************************************
 * $Id$
 *
 * FancyDB
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYDBCONNECTIONBINDER_H_
#define FANCYDBCONNECTIONBINDER_H_

#include <fancydb.h>
#include <fancysessioncontextfactory.h>

namespace Fancy {

class String;

namespace DB {

class Connection;
class ConnectionPool;

class FANCYDB_API DBConnectionBinder : public virtual Fancy::SessionContextFactory {

protected:
	//DBConnectionBinder();
    //virtual ~DBConnectionBinder();

public:

    /**
     * Return a new instance with a default specific key: "Fancy::DB::DBConnectionBinder::pooledDBConnection"
     */
    static ptr_t newInstance(const Fancy::ObjPtr<Fancy::DB::ConnectionPool> &dbConnectionPool);

    /**
     * Return a new instance with the specified specific key.
     */
    static ptr_t newInstance(const Fancy::ObjPtr<Fancy::DB::ConnectionPool> &dbConnectionPool, const Fancy::Object::ptr_t &specificKey);

    virtual Fancy::ObjPtr<Fancy::DB::Connection> getConnection() = 0;

    static Fancy::ObjPtr<Fancy::DB::Connection> getConnection_s(const Fancy::Object::ptr_t &specificKey);
    static Fancy::ObjPtr<Fancy::DB::Connection> getConnection_s();
};

}} // end namespaces

#endif /* FANCYDBCONNECTIONBINDER_H_ */
