/***********************************************************
 * $Id$
 *
 * FancyDB
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYDBCONNECTIONBOUND_H_
#define FANCYDBCONNECTIONBOUND_H_

#include <fancydb.h>
#include <fancyobject.h>

namespace Fancy {

namespace DB {

class Connection;

/**
 * This interface is implemented by all spin-offs from a @c Connection
 * like statements or transactions.
 */
class FANCYDB_API ConnectionBound: public virtual Fancy::Object {
public:
	typedef Fancy::ObjPtr<ConnectionBound> ptr;

	/**
	 * Get the underlying connection.
	 */
	virtual Fancy::ObjPtr<Connection> getConnection() const = 0;

protected:
	ConnectionBound();
	virtual ~ConnectionBound();
};

}

}

#endif /* FANCYDBCONNECTIONBOUND_H_ */
