/***********************************************************
 * $Id$
 *
 * FancyDB
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

#ifndef FANCYDB_EXCEPTION_H
#define FANCYDB_EXCEPTION_H

#include <fancydb.h>
#include <fancyexception.h>

//extern "C" {
//  typedef struct st_mysql MYSQL;
//}

namespace Fancy {
  namespace DB {

    class FANCYDB_API Exception : public Fancy::Exception
    {
    public:
      Exception (int facility,
                 int priority,
                 const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,4,5)))
#endif
;

      ~Exception() throw();

    protected:
      Exception (fancylog_service *service,
                 int facility,
                 int priority ) throw();
    };

    class FANCYDB_API DBException : public Exception
    {
    public:
      DBException (int _err,
    		       const char *strerr,
                   int facility,
                   int priority,
                   const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,6,7)))
#endif
        ;
      ~DBException() throw();

      int getErrno() const throw();
      virtual bool isServerGone() const throw() = 0;
    
    protected:
      DBException (int _err,
    		       int facility,
                   int priority) throw();

      void appendDBError(const char *strerr) throw();

    private:
      unsigned err;
    };
  }
}

#endif
